

subroutine CalcEnergy(Pos, PosChargeWall, FreeCharge, screen, strength, M, L, rc, PEnergy, Dim, NAtom,Nwall)
    implicit none
    integer, intent(in) :: M, Dim, NAtom, Nwall
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
    real(8), intent(in), dimension(0:NAtom-1) :: FreeCharge
    real(8), intent(in), dimension(0:Nwall-1, 0:Dim-1) :: PosChargeWall
    real(8), intent(in) :: L, rc, screen, strength
    real(8), intent(out) :: PEnergy
    real(8), dimension(Dim) :: rij, Posi, rik
    real(8), parameter :: k = 3000., r0 = 1.
    !======== YOUR CODE HERE ========
    real(8) :: Shift, rc2, ro2, k2, d, rk, rk2
    real(8) :: d2, id2, id6, id12
    integer :: i,j,w
    PEnergy = 0.
    Shift = -4. * (rc**(-12) - rc**(-6))
    rc2 = rc * rc
    ro2 = r0*r0
    !k2 = k / 2.
    do i = 0, NAtom - 1
        !store Pos(i,:) in a temporary array for faster access in j loop
        Posi = Pos(i,:)
        do j = i + 1, NAtom - 1
            rij = Pos(j,:) - Posi
            rij(:2) = rij(:2) - L* dnint(rij(:2) / L)
            d2 = sum(rij * rij)
            
            if (FreeCharge(i) /= 0 .and. FreeCharge(j) /= 0) then
                    PEnergy = PEnergy + FreeCharge(i)*FreeCharge(j)*strength*exp(-screen*d)/d
                  
                    !this is an electrostatic interaction (polymer-polymer,
                    !polymer-counterion, or counterion-counterion
                
            endif

            if (j == i + 1 .and. mod(j, M) > 0 .and. FreeCharge(j) /=1) then
                !This is a bonded interatction;
                !use the harmonic bond potential here
                d = sqrt(d2)
                PEnergy = PEnergy + k * (d2 + ro2 - 2. * d * r0) / 2.
                    
            else
                !This is a nonbonded interaction;
                !use the Lennard-Jones potential here
                if (d2 > rc2) then
                    cycle
                endif
                id2 = 1. / d2           !inverse squared distance
                id6 = id2 * id2 * id2   !inverse sixth distance
                id12 = id6 * id6        !inverse twelfth distance
                PEnergy = PEnergy + 4. * (id12 - id6) + Shift
            endif
        enddo

         do w = 0, Nwall-1
                if (FreeCharge(i) /= 0) then
                        !this is an electrostatic interaction. screened coulomb:
                        rik = Posi - PosChargeWall(w,:)
                        rik(:2) = rik(:2) - L * dnint(rik(:2)/L)
                        rk2 = sum(rik*rik)
                        rk = sqrt(rk2)
                        PEnergy = PEnergy + FreeCharge(i)*strength*exp(-screen*rk)/rk
                       
                endif
        enddo
    enddo
end subroutine


subroutine CalcEnergyForces(Pos,PosChargeWall,FreeCharge,screen,strength,M,L,rc,PEnergy,Forces,Dim,NAtom,Nwall)
    implicit none
    integer, intent(in) :: M, Dim, NAtom, Nwall
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
    real(8), intent(in), dimension(0:NAtom-1) :: FreeCharge
    real(8), intent(in), dimension(0:Nwall-1, 0:Dim-1) :: PosChargeWall
    real(8), intent(in) :: L, rc, screen, strength
    real(8), intent(out) :: PEnergy
    real(8), intent(inout), dimension(0:NAtom-1, 0:Dim-1) :: Forces
    real(8), dimension(Dim) :: rij, Fij, Posi, rik, Fik
!f2py intent(in, out) :: Forces
    real(8), parameter :: k = 3000., r0 = 1.
    !======== YOUR CODE HERE ========
    real(8) :: d, d2, id2, id6, id12
    real(8) :: rc2, ro2, Shift, k2, rk, rk2
    integer :: i,j,w
    PEnergy = 0.
    Forces = 0.
    Shift = -4. * (rc**(-12) - rc**(-6))
    rc2 = rc * rc
    ro2 = r0*r0
   ! k2 = k / 2.
    do i = 0, NAtom - 1
        !store Pos(i,:) in a temporary array for faster access in j loop
        Posi = Pos(i,:)
        do j = i + 1, NAtom - 1
            rij = Pos(j,:) - Posi
            rij(:2) = rij(:2) - L* dnint(rij(:2) / L)
            d2 = sum(rij * rij)

            if (FreeCharge(i) /= 0 .and. FreeCharge(j) /= 0) then
                    PEnergy = PEnergy + FreeCharge(i)*FreeCharge(j)*strength*exp(-screen*d)/d
                    Fij = - rij * FreeCharge(i)*FreeCharge(j) * strength * exp(-screen*d) * (screen + 1/d)/d2
                    
                    Forces(i,:) = Forces(i,:) + Fij
                    Forces(j,:) = Forces(j,:) - Fij
                    !this is an electrostatic interaction (polymer-polymer,
                    !polymer-counterion, or counterion-counterion
                
            endif


            if (j == i + 1 .and. mod(j, M) > 0 .and. FreeCharge(j) /= 1) then
                    !This is a bonded interatction;
                    !use the harmonic bond potential here
                    d = sqrt(d2)
                    PEnergy = PEnergy + k * (d2 + ro2 - 2. * d * r0) / 2.
                    Fij = rij* k * (1 - (r0 / d))
                    Forces(i,:) = Forces(i,:) + Fij 
                    Forces(j,:) = Forces(j,:) - Fij
            else
                    !This is a nonbonded interaction;
                    !use the Lennard-Jones potential here

                if (d2 > rc2) then
                    cycle
                endif

                id2 = 1. / d2           !inverse squared distance
                id6 = id2 * id2 * id2   !inverse sixth distance
                id12 = id6 * id6        !inverse twelfth distance
                PEnergy = PEnergy + 4. * (id12 - id6) + Shift
                Fij = rij * ((-48. * id12 + 24. * id6) * id2) 
                Forces(i,:) = Forces(i,:) + Fij 
                Forces(j,:) = Forces(j,:) - Fij
            endif
        enddo

         do w = 0, Nwall-1
                if (FreeCharge(i) /= 0) then
                        !this is an electrostatic interaction. screened coulomb:
                        rik = Posi - PosChargeWall(w,:)
                        rik(:2) = rik(:2) - L * dnint(rik(:2)/L)
                        rk2 = sum(rik*rik)
                        rk = sqrt(rk2)
                        PEnergy = PEnergy + FreeCharge(i)*strength*exp(-screen*rk)/rk
                        Fik = -rik * FreeCharge(i) * strength * exp(-screen*rk) * (screen + 1/rk)/rk2
                        Forces(i,:) = Forces(i,:) + Fik !update for on free charge only
                endif
        enddo
    enddo
end subroutine


subroutine VVIntegrate(Pos,Vel,Accel,PosChargeWall,FreeCharge,screen,strength,M,L,rc,dt,KEnergy,PEnergy, Dim, NAtom, Nwall)
    implicit none
    integer, intent(in) :: M, Dim, NAtom, Nwall
    real(8), intent(in) :: L, rc, dt, screen, strength
    real(8), intent(in), dimension(0:NAtom-1) :: FreeCharge
    real(8), intent(in), dimension(0:Nwall-1, 0:Dim-1) :: PosChargeWall
    real(8), intent(inout), dimension(0:NAtom-1, 0:Dim-1) :: Pos, Vel, Accel
!f2py intent(in,out) :: Pos, Vel, Accel
    real(8), intent(out) :: KEnergy, PEnergy
    real(8), parameter :: delta = 0.0001
    real(8), dimension(Dim) :: Posi
    integer :: i,x
    external :: CalcEnergyForces
    Pos = Pos + dt * Vel + 0.5 * dt*dt * Accel
    Vel = Vel + 0.5 * dt * Accel

    !Do hardwall here
    do x = 0, NAtom-1
          if (Pos(x,2) > L/2.) then
              Pos(x,2) = L/2. - delta
              Vel(x,2) = -Vel(x,2)
          elseif (Pos(x,2) < -L/2.) then
                  Pos(x,2) = -L/2. + delta
                  Vel(x,2) = -Vel(x,2)
          endif
    enddo

    call CalcEnergyForces(Pos, PosChargeWall, FreeCharge, screen, strength, M, L, rc, PEnergy, Accel, Dim, NAtom,Nwall)


    !minimum image conventon positons
    do i = 0 , NAtom-1
        Posi = Pos(i,:)
        Pos(i,:) = Posi - L * dnint(Posi/L)
    enddo
     

    Vel = Vel + 0.5 * dt * Accel
    KEnergy = 0.5 * sum(Vel*Vel)
end subroutine


